(load "element-generator.scm")

;test if the node contains a formula
(define (node-contains? set node formula)
(begin
	(or (set-contains set (list 'formula node formula)) (set-contains set (list 'mark node formula)))))

;test if a node contains a formula matching with the pattern formula-pattern
;(node-contains-pattern? '((formula 1 a) (formula 1 (diamond a))) 1 '(diamond A))
(define (node-contains-pattern? set node formula-pattern)
       (not (null? (set-extract-with-unification set (list 'formula node formula-pattern)))))

;test if there is a relation of that name from node1 to node2
(define (linked? set node1 relationname node2)
(begin
	(set-contains set (list node1 'link relationname node2))))


(define (expression-match? expression match)
	(unifyPattern1WithTerm2 match expression))
	
(define node-contains node-contains?)
(define contains node-contains?)
(define contains? node-contains?)


(define (node-empty? set node)
	(set-empty? (set-extract-with-unification set (list 'formula node '|PHI|))))
	
	
(define (actionelementaire? action)
  (not (list? action)))
  
(define (proposition? |P|)
	  (not (list? |P|)))
 
 
 
(define (literal? |P|)
	(let ( (v (unifyPattern1WithTerm2 '(not |C|) |P|)) )
    (if v
		(proposition? (substitution-variable-valeur-get v '|C|))
        (proposition? |P|)
        )))
	  
	  
  
(define (formula-length phi)
  (if (list? phi)
      (apply + (map formula-length phi))
      1))




;(formula-disjonction-make '(p q r))
(define (formula-disjonction-make formulasSet)
  (if (null? formulasSet)
      'bottom
      (if (null? (cdr formulasSet))
          (car formulasSet)
          `(,(car formulasSet) or ,(formula-disjonction-make (cdr formulasSet))))))



(define (worldsformulasincluded? set world1 world2)
  (begin
   ; (display set)
        (let ( (world1sformulas  (unify-pattern-elementsofset `(formula ,world1 |C|) set))
               (world2sformulas  (unify-pattern-elementsofset `(formula ,world2 |C|) set)) )
        (begin
          (set-include? world1sformulas world2sformulas))
        )))
  

;(node-formulas-get '((formula 1 p)) 1)
;(node-formulas-get '((formula 1 p) (formula 2 q) (formula 1 r)) 1)
(define (node-formulas-get set world)
  (subtitutions-set-getvalues (unify-pattern-elementsofset `(formula ,world |C|) set) '|C|))




 (define (sameformulas? set world1 world2)
  (begin
   ; (display set)
        (let ( (world1sformulas  (unify-pattern-elementsofset `(formula ,world1 |C|) set))
               (world2sformulas  (unify-pattern-elementsofset `(formula ,world2 |C|) set)) )
        (begin
		   ; (display "sameformulas?")
		   ; (newline)
          ; (display world1sformulas)
          ; (newline)
          ; (newline)
          ; (display world2sformulas)
          ; (newline)
          ; (newline)
          (set-equal? world1sformulas world2sformulas))
        )))
		
		
(define (diff? a b)
	(not (equal? a b)))
	
	
(define (square a) (* a a))
	
	
;generates a new symbol
(define (new-symbol)
  (begin (element-generate)
         element-generated-get))






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;LIST
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;generates a list of that size with new symbols (the list contains different symbols)
;(list-new-different-symbols 3) returns '(n1 n2 n3)
(define (list-new-different-symbols size)
	(if (= size 0)
		()
		(cons (new-symbol) (list-new-different-symbols (- size 1)))))
		
(define list-size length)

;(list-greatest-strict-prefix '(1 2 3))
(define (list-greatest-strict-prefix L)
    (if (null? L)
		()
		(if (null? (cdr L))
			()
			(cons (car L) (list-greatest-strict-prefix (cdr L))))))


;(list-element-last '(1 2))
;(list-element-last '(1 2 3))
(define (list-element-last L)
	(if (null? L)
		0
		(if (null? (cdr L))
			(car L)
			(list-element-last (cdr L)))))

;generates the list where e is put at the end of L
;example (list-cond-end '(1 2) 3) returns '(1 2 3)
(define (list-cons-end L e)
	(if (null? L)
		`(,e)
		(cons (car L) (list-cons-end (cdr L) e))))