; (module-export machinestate-create)
; (module-export machinestate-set-get)
; (module-export machinestate-events-get)
; (module-export events-add-to-each-queue)
; (module-export events1-delete-event3-for-rule2)
; (module-export events-forrule-get)
; (module-export machinestate-elementsadd)
; (module-export machinestate-event-delete)
; (module-export machinestate-events-forrule-get)
; (module-export machinestate-nothingtodo?)
; (module-export machinestate-events-number )
; (module-export machinestate-compterendu-display)
; (module-export machinestate-nodoublons)




;represents an array containing all the rules
(define rulesArray (make-vector 3 '()))


;fill the array rulesArray with the list of rules rules
(define (rulesArrayFill rules) 
	(set! rulesArray (make-vector (set-card rules)))
  	(letrec ((loop (lambda (i R) (if (>= i 0) (begin (vector-set! rulesArray i (car R)) (loop (- i 1) (cdr R)))))))
		(loop (- (set-card rules) 1) rules)))
;rem : (list->vector rules)) does not work for a reason I ignore.

;get the i^th rule
(define (ruleFromIndex i)
  (vector-ref rulesArray i))

;get the index i of the rule in the array rulesArray
(define (ruleToIndex rule) (vector-index rulesArray rule))

;gives the index of an element e in the vector V
(define (vector-index V e)
  (letrec ((loop (lambda (i) (if (< i 0)
                                 -1
                                 (if (equal? (vector-ref V i) e)
                                     i
                                     (loop (- i 1)))))))
    (loop (- (vector-length V) 1))))

;apply the function f to each element of the vector V
;(vector-map (make-vector 3 '()) (lambda (l) (cons 1 l)))
(define (vector-map V f)
  (letrec ((loop (lambda (i) (if (>= i 0)
                                 (begin
                                   (vector-set! V i (f (vector-ref V i)))
                                   (loop (- i 1)))))))
    (begin (loop (- (vector-length V) 1))
           V)))


;gives a new vector containing the same elements (the elements are not copied)
(define (vector-copy V)
  (letrec ((copy (make-vector (vector-length V)))
           (loop (lambda (i) (if (< i 0)
                                 -1
                                 (begin
                                   (vector-set! copy i (vector-ref V i))
                                   (loop (- i 1)))))))
    (begin (loop (- (vector-length V) 1))
           copy)))


;gives the number of rules
(define (rulesNumber) (vector-length rulesArray))





;create a new machine state where S = set of terms, rules = set of rewriting rules
;a machine state is represented as a couple (S e) where e is a list where for each rules, we have a set of "events" for each rule (= term)
(define (machinestate-create S rules)
  (begin
    (rulesArrayFill rules)
    (couple-create S
                   (make-vector (set-card rules) S))))

;returns the set of terms of the machine state
(define (machinestate-set-get ms)
  (couple-first ms))

;returns the events of the machine state
(define (machinestate-events-get ms)
  (if (couple? ms)
      (couple-second ms)
      (unsatisfiable  "error in machinestate-events-get: the machine is not a couple (T, E)!")))

;E = events of a machine state
;elementsSet = set of terms
;(events-add-to-each-queue (make-vector 3 '()) '((formula w 1)))
;returns the events of a machine state where we have added elementsSet to each queue of each rule
(define (events-add-to-each-queue E elementsSet)
  (begin
    (do ((i (- (vector-length E) 1) (- i 1) )) ((< i 0))
      (let* ((rule (ruleFromIndex i))
             (queue (vector-ref E i))
        	(f (lambda (term) (rule-concernedbynewterm? rule term) )))
        ;          (vector-set! E i	(set-addelements queue (set-filter elementsSet f)))))
        (vector-set! E i (set-addelements queue (set-filter elementsSet f)))))
    E))


;returns the events of a machine state where the event is removed from the queue of the rule
(define (events1-delete-event3-for-rule2 E rule event)
  (begin
    (vector-set! E (ruleToIndex rule) (set-delete (vector-ref E (ruleToIndex rule)) event))
    E))


;returs true iff ALL queue of ALL rules are empty in the events of a machine state
;(events-allempty? (make-vector 3 '()))
;(events-allempty? (make-vector 3 '(a)))
(define (events-allempty? E)
  (letrec ((loop (lambda (i) (if (= i 0)
                                 #t
                                 (if (null? (vector-ref E i)) ;set-isempty
                                     (loop (- i 1))
                                     #f)))))
    (loop (- (vector-length E) 1))))



;returns the sum of the set of ALL events in ALL queues
(define (events-number E)
  (if (null? E)
      0
      (+ (set-card (couple-second (car E)))
         (events-number (cdr E)))))


;give the set of all events corresponding of the rule in the events E of a machine state
(define (events-forrule-get E rule)
  (vector-ref E (ruleToIndex rule)))
;	(couple-second (assoc rule E)))
;assq, search using eq?
;assv search using eqv?
;assoc search using equal?



; (define (events-forrule-get E rule)
; (if (null? E)
; #f
; (if (eq? (couple-first (car E)) rule)
; (couple-second (car E))
; (events-forrule-get (cdr E) rule))))


;add the set of terms  elementsSet to the machine state ms
;it adds elementsSet to the set of terms
;it adds elementsSet to each queue
(define (machinestate-elementsadd ms elementsSet)
  (couple-create
   (set-addelements-even-if-contained (machinestate-set-get ms) elementsSet)
   (events-add-to-each-queue (machinestate-events-get ms) elementsSet)))

;delete the event (a term) of the rule rule in the machine state ms
(define (machinestate-event-delete ms rule event)
  (begin
    ;          (display "arf : ")
    ;          (display ms)
    ;          (newline)
    ;          (display "rule : ")
    ;          (display rule)
    ;          (newline)
    ;          (newline)
    ;          (display (events1-delete-event3-for-rule2 (machinestate-events-get ms) rule event))
    ;          (newline)
    ;          (newline)
    (couple-create
     (machinestate-set-get ms)
     (events1-delete-event3-for-rule2 (machinestate-events-get ms) rule event)
     
     )         
    ))


;returns the set of events corresponding of the rule in the machine state ms
(define (machinestate-events-forrule-get ms rule)
  (events-forrule-get (machinestate-events-get ms) rule))

;returns true iff there is nothing to do in the machine state (the state is final)
;it corresponds to the fact that ALL queues (for each rule) are empty (there is no events anymore)
(define (machinestate-nothingtodo? ms)
  (events-allempty? (machinestate-events-get ms)))

;returns the number of events in ALL queues in the machine state
(define (machinestate-events-number ms)
  (events-number (machinestate-events-get ms)))

;display a message which says the size of the premodel and the number of events in the queues
(define (machinestate-compterendu-display ms)
  (begin
    (display "size of premodel: ")
    (display (set-card (machinestate-set-get ms)))
    (display " terms. Number of events: ")
    (display (machinestate-events-number ms))
    (newline)))


;returns a cleaned machine state, similar to ms, but there is no doublons in the set of terms  
(define (machinestate-nodoublons ms)
  (couple-create (set-nodoublons (machinestate-set-get ms)) (machinestate-events-get ms)))


  
(define (machinestate-copy ms)
  (couple-create
   (machinestate-set-get ms)
   (vector-copy  (machinestate-events-get ms))))