/*
 * GraphPanelEditable.java
 *
 * Created on 27 avril 2009, 16:20
 */

package lotrecscheme;

import java.awt.Graphics2D;
import java.awt.Point;
import java.util.ArrayList;
import javax.swing.JOptionPane;

/**
 *
 * @author  proprietaire
 */
public class GraphPanelEditable extends GraphPanel {
    private PenSketch penSketch = null;
    private GraphVertex sommet_debut = null;
    private GraphVertex sommet_fin = null;
    private boolean editable = true;

    /** Creates new form GraphPanelEditable */
    public GraphPanelEditable() {
        initComponents();
        
        canVerticeDialogToSeeContentsSet(false);
    }

    void setEditable(boolean b) {
        editable = b;
        
        canVerticeDialogToSeeContentsSet(!editable);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu = new javax.swing.JPopupMenu();
        cmdNodeName = new javax.swing.JMenuItem();
        cmdNodeContents = new javax.swing.JMenuItem();
        cmdNodeAdd = new javax.swing.JMenuItem();
        cmdNodeDelete = new javax.swing.JMenuItem();

        jPopupMenu.setName("jPopupMenu"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(lotrecscheme.LispuApp.class).getContext().getResourceMap(GraphPanelEditable.class);
        cmdNodeName.setText(resourceMap.getString("cmdNodeName.text")); // NOI18N
        cmdNodeName.setName("cmdNodeName"); // NOI18N
        cmdNodeName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdNodeNameActionPerformed(evt);
            }
        });
        jPopupMenu.add(cmdNodeName);

        cmdNodeContents.setText(resourceMap.getString("cmdNodeContents.text")); // NOI18N
        cmdNodeContents.setName("cmdNodeContents"); // NOI18N
        cmdNodeContents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdNodeContentsActionPerformed(evt);
            }
        });
        jPopupMenu.add(cmdNodeContents);

        cmdNodeAdd.setText(resourceMap.getString("cmdNodeAdd.text")); // NOI18N
        cmdNodeAdd.setName("cmdNodeAdd"); // NOI18N
        cmdNodeAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdNodeAddActionPerformed(evt);
            }
        });
        jPopupMenu.add(cmdNodeAdd);

        cmdNodeDelete.setText(resourceMap.getString("cmdNodeDelete.text")); // NOI18N
        cmdNodeDelete.setName("cmdNodeDelete"); // NOI18N
        cmdNodeDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdNodeDeleteActionPerformed(evt);
            }
        });
        jPopupMenu.add(cmdNodeDelete);

        setComponentPopupMenu(jPopupMenu);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                formMousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                formMouseReleased(evt);
            }
        });
        addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                formMouseDragged(evt);
            }
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                formMouseMoved(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 350, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 350, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents




    private void nodeContentsEdit(GraphVertex v)
    {
        GraphEditorGraphVertexEditorDialog d = new GraphEditorGraphVertexEditorDialog(null, v.getName(), true);
        d.setContents(v.getFormulas());
        d.setVisible(true);

        if(d.isResultOK())
        {
            v.setFormulas(d.getContents());
            v.widthHeightCompute(getGraphics());
            repaint();
        }
    }





private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
if(!editable)
    return;

    if(evt.getClickCount() > 1)
        //double-click
    {
        GraphVertex v = sommet_souscurseur(evt.getPoint());
        
        if(v != null)
        {
            nodeContentsEdit(v);
        }
        
        
        GraphEdge e = arc_souscurseur(evt.getPoint());
        
        if(e != null)
        {
            GraphEditorGraphEdgeEditorDialog d = 
                    new GraphEditorGraphEdgeEditorDialog(null, 
                            e.getSource().getName(),e.getDest().getName(), true);
            d.setContents(e.getRelationsName());
            d.setVisible(true);
            
            if(d.isResultOK())
            {
                e.setRelationsName(d.getContents());
                repaint();
            }
        }
        
    }
}//GEN-LAST:event_formMouseClicked

private void formMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMousePressed

    if(!editable)
         return;
    penSketch = new PenSketch();
    penSketch.styloPointAjouter(evt.getPoint());
    sommet_debut = sommet_contoursouscurseur(evt.getPoint());
}//GEN-LAST:event_formMousePressed

private void formMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseReleased
     
    if(!editable)
        return;
    
    if(penSketch.isGribouilli() && !isModeDeplacementNoeud())
    {
        ArrayList<Point> pts = penSketch.getPointsWhereWeErase();
        ArrayList<GraphEdge> es = getEdgesUnder(pts);
        
        for(GraphEdge e : es)
        {
            arc_supprimer(e);
        }
        ArrayList<GraphVertex> vs = getVerticesUnder(pts);
        
        for(GraphVertex v : vs)
        {
            if(getVertices().size() > 1)
                 sommet_supprimer(v);
        }
        
    }
        
    
    if(!penSketch.isPoint() && 
            
            !penSketch.isGribouilli() &&
            !isModeDeplacementNoeud())
    {
        sommet_fin = sommet_presquesouscurseur(evt.getPoint());

        if((sommet_debut != null) && (sommet_fin != null))
        {
            arc_ajouter("", sommet_debut.getName(), sommet_fin.getName());
        }
        else if((sommet_debut != null) && (sommet_fin == null))
        {
            sommet_fin = sommet_ajouter();
            sommet_fin.setPositionMiddle(evt.getPoint());
            arc_ajouter("", sommet_debut.getName(), sommet_fin.getName());
        }

        
    }
    
    repaint();
}//GEN-LAST:event_formMouseReleased

private void formMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseDragged

    if(!editable)
        return;
    
    if(!isModeDeplacementNoeud())
    {
        penSketch.styloPointAjouter(evt.getPoint());
        penSketch.afficher((Graphics2D) getGraphics());
        
        if(!penSketch.isGribouilli())
        {
            // sommet_fin = graphPanel.sommet_presquesouscurseur(evt.getPoint());
            // graphPanel.NoVertexAsSpecial();
            // graphPanel.setVertexAsSpecial(sommet_fin);
        }
    }
    
    if(penSketch != null)
        if(penSketch.isGribouilli())
             modifierSourisCurseurGomme();
}//GEN-LAST:event_formMouseDragged

private void formMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseMoved
   
    if(!editable)
         return;
    
    if(sommet_contoursouscurseur(evt.getPoint()) != null)
          modifierSourisCurseurCrayon();
}//GEN-LAST:event_formMouseMoved

private void cmdNodeContentsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdNodeContentsActionPerformed
    if(getGraphVertexCurrent()  != null)
    {
        nodeContentsEdit(getGraphVertexCurrent());
    }
}//GEN-LAST:event_cmdNodeContentsActionPerformed

private void cmdNodeNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdNodeNameActionPerformed
    if(getGraphVertexCurrent()  != null)
    {
        nodeNameEdit(getGraphVertexCurrent());
    }
}//GEN-LAST:event_cmdNodeNameActionPerformed

private void cmdNodeAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdNodeAddActionPerformed

    String reponse = JOptionPane.showInputDialog(this, "Give me the name of the new node:");

    sommet_ajouter_si_existe_pas(reponse);
}//GEN-LAST:event_cmdNodeAddActionPerformed

private void cmdNodeDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdNodeDeleteActionPerformed
    sommet_supprimer(getGraphVertexCurrent());
    
}//GEN-LAST:event_cmdNodeDeleteActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem cmdNodeAdd;
    private javax.swing.JMenuItem cmdNodeContents;
    private javax.swing.JMenuItem cmdNodeDelete;
    private javax.swing.JMenuItem cmdNodeName;
    private javax.swing.JPopupMenu jPopupMenu;
    // End of variables declaration//GEN-END:variables

    private void nodeNameEdit(GraphVertex graphVertexCurrent) {
        String reponse = JOptionPane.showInputDialog(this, "Set the name of the node");

        if(reponse == null)
            return;

        if(reponse.isEmpty())
            return;
        
        graphVertexCurrent.setNom(reponse);
        repaint();
        
    }

}
